<?php

class rdc_chambre_eclairage extends hook
{
	public $hookName = "rdc_chambre_eclairage";
	public $active = true;			//enable/disable hook (true => enabled)
	public $delay = 5;				// amount of time in $timeunit
	public $timeUnit = "minute";	// unit of time for delay, second, minute, hour, day, week, month, year
	public $luminance_min = 60;
	public $luminance_max = 3000;
	protected $devicelist = array(
		RDC_CHAMBRE_AMBIANCE => array("state", false),		// "ON"/"OFF"
		RDC_CHAMBRE_ECLAIRAGE => array("state_l1", false),	// "ON"/"OFF"
		RDC_CHAMBRE_MVMT => array("occupancy", false),
		RDC_CHAMBRE_ARMOIRE_GAUCHE => array("contact", false)
	);

	// callback fonction. Is called with these 3 parameters
	// $device 		-> calling device
	// $property 	-> property of the device (given by mqtt)
	// $value 		-> value of the property
	public function callBack($device, $property, $value)
	{
		global $devices, $indexDevices;
		$lux = $indexDevices[RDC_CHAMBRE_LUMINOSITE]->properties["illuminance_lux"];
		$targetAmbiance = $indexDevices[RDC_CHAMBRE_AMBIANCE];
		$targetEclairage = $indexDevices[RDC_CHAMBRE_ECLAIRAGE];

		if ($property == "occupancy" and $value == "ON")
		{
			$this->send($targetAmbiance, "ON", "OFF", AUTO);
		}elseif ($property == "contact" and $value = true and getValue(RDC_CHAMBRE_ECLAIRAGE, "state_l1") == "OFF")
		{
			$this->send($targetEclairage, "ON", "OFF", AUTO);
		}
		logger (INFO, sprintf(_("%s: notification received from MQTT from %s => parameter: %s value: %s"), $this->hookName, $device->friendlyName, $property, bool2string($value)), __FILE__ . ":" . __LINE__);
	}

	private function send($deviceObject, $state, $delayState = false, $method = MANUAL)
	{
		global $devices, $indexDevices;
		$msg = array("state" => $state);
		if ($deviceObject->properties["state"]["value"] != $state)
		{
			logger(INFO, sprintf(_("publishing message: %s to %s"), json_encode($msg), $deviceObject->friendlyName), __FILE__ . ":" . __LINE__);
			$deviceObject->payload = $msg;
			$deviceObject->set();
			$deviceObject->method = $method;
		}else
		{
			logger(INFO, sprintf(_("not publishing message: %s to %s, already set"), json_encode($msg), $deviceObject->friendlyName), __FILE__ . ":" . __LINE__);

		}
		//echo 'delaystate = ' . var_dump($delayState);
		if ($delayState !== false) 	setDelay($deviceObject, $this->delay, $this->timeUnit, "state", $delayState, true);
	}
}

$hooks["rdc_chambre_eclairage"] = new rdc_chambre_eclairage();
?>
